com.io7m.r2.core

## Class R2GeometryBufferDescription

- java.lang.Object
- - com.io7m.r2.core.R2GeometryBufferDescription

- All Implemented Interfaces:
    R2GeometryBufferDescriptionType, R2RenderTargetDescriptionType

      @Generated(value={"Immutables.generator","R2GeometryBufferDescriptionType"})
      public final class R2GeometryBufferDescription
      extends Object
      implements R2GeometryBufferDescriptionType

  The type of geometry buffer descriptions.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2GeometryBufferDescription.Builder` Builds instances of type `R2GeometryBufferDescription`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.io7m.jareas.core.AreaInclusiveUnsignedLType` | `area()`
    `static R2GeometryBufferDescription.Builder` | `builder()` Creates a builder for `R2GeometryBufferDescription`.
    `R2GeometryBufferComponents` | `components()`
    `static R2GeometryBufferDescription` | `copyOf(R2GeometryBufferDescriptionType instance)` Creates an immutable copy of a `R2GeometryBufferDescriptionType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2GeometryBufferDescription` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `area`, `components`.
    `static R2GeometryBufferDescription` | `of(com.io7m.jareas.core.AreaInclusiveUnsignedLType area, R2GeometryBufferComponents components)` Construct a new immutable `R2GeometryBufferDescription` instance.
    `String` | `toString()` Prints the immutable value `R2GeometryBufferDescription` with attribute values.
    `R2GeometryBufferDescription` | `withArea(com.io7m.jareas.core.AreaInclusiveUnsignedLType value)` Copy the current immutable object by setting a value for the `area` attribute.
    `R2GeometryBufferDescription` | `withComponents(R2GeometryBufferComponents value)` Copy the current immutable object by setting a value for the `components` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### area

          public com.io7m.jareas.core.AreaInclusiveUnsignedLType area()

      Specified by:
        `area` in interface `R2GeometryBufferDescriptionType`
      Specified by:
        `area` in interface `R2RenderTargetDescriptionType`
      Returns:
        The value of the `area` attribute

    - #### components

          public R2GeometryBufferComponents components()

      Specified by:
        `components` in interface `R2GeometryBufferDescriptionType`
      Returns:
        The components that will be allocated in the geometry buffer

    - #### withArea

          public final R2GeometryBufferDescription withArea(com.io7m.jareas.core.AreaInclusiveUnsignedLType value)

      Copy the current immutable object by setting a value for the `area` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for area
      Returns:
        A modified copy of the `this` object

    - #### withComponents

          public final R2GeometryBufferDescription withComponents(R2GeometryBufferComponents value)

      Copy the current immutable object by setting a value for the `components` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for components
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2GeometryBufferDescription` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `area`, `components`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2GeometryBufferDescription` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2GeometryBufferDescription of(com.io7m.jareas.core.AreaInclusiveUnsignedLType area,
                                                       R2GeometryBufferComponents components)

      Construct a new immutable `R2GeometryBufferDescription` instance.
      Parameters:
        `area` - The value for the `area` attribute
        `components` - The value for the `components` attribute
      Returns:
        An immutable R2GeometryBufferDescription instance

    - #### copyOf

          public static R2GeometryBufferDescription copyOf(R2GeometryBufferDescriptionType instance)

      Creates an immutable copy of a `R2GeometryBufferDescriptionType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2GeometryBufferDescription instance

    - #### builder

          public static R2GeometryBufferDescription.Builder builder()

      Creates a builder for `R2GeometryBufferDescription`.
      Returns:
        A new R2GeometryBufferDescription builder

Copyright © 2017 <code@io7m.com> http://io7m.com